=== debian/control ===
Source: genomethreader
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Sascha Steinbiss <satta@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               genometools,
               libgenometools0-dev,
               libvmatch-dev,
               zlib1g-dev,
               libbz2-dev,
               libexpat1-dev,
               liblua5.1-0-dev,
               libtre-dev,
               asciidoctor
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/genomethreader
Vcs-Git: https://salsa.debian.org/med-team/genomethreader.git
Homepage: https://genomethreader.org
Rules-Requires-Root: no

Package: genomethreader
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Built-Using: vmatch (= ${libvmatch-dev:Version})
Description: software tool to compute gene structure predictions
 GenomeThreader is a software tool to compute gene structure predictions.
 The gene structure predictions are calculated using a similarity-based
 approach where additional cDNA/EST and/or protein sequences are used to
 predict gene structures via spliced alignments. GenomeThreader was motivated
 by disabling limitations in GeneSeqer, a popular gene prediction program
 which is widely used for plant genome annotation.
