=== debian/changelog ===
genomethreader (1.7.3+dfsg-8) unstable; urgency=medium

  * Enable building twice in a row.
    Closes: #1044585, #1049675
  * Bump Standards-Version.
  * Add d/copyright section for debian/ directory.

 -- Sascha Steinbiss <satta@debian.org>  Mon, 18 Dec 2023 18:19:28 +0100

genomethreader (1.7.3+dfsg-7) unstable; urgency=medium

  * Fix watchfile to detect new versions on github
  * Bump Standards-Version.

 -- Sascha Steinbiss <satta@debian.org>  Sat, 08 Oct 2022 13:52:00 +0000

genomethreader (1.7.3+dfsg-6) unstable; urgency=medium

  * Fix d/watch to work with GitHub link structure.
  * Bump Standards-Version.
  * Add Rules-Requires-Root.
  * Use debhelper 13.
  * Add upstream repository metadata.

 -- Sascha Steinbiss <satta@debian.org>  Tue, 28 Sep 2021 22:49:50 +0200

genomethreader (1.7.3+dfsg-5) unstable; urgency=medium

  * Add autopkgtest.

 -- Sascha Steinbiss <satta@debian.org>  Sat, 08 Feb 2020 15:41:00 +0100

genomethreader (1.7.3+dfsg-4) unstable; urgency=medium

  * Skip fastdp tests on i386 (see
    https://github.com/genometools/genomethreader/issues/14)
  * Do not include CFLAGS in binary for improved reproducibility.

 -- Sascha Steinbiss <satta@debian.org>  Thu, 23 Jan 2020 13:32:02 +0100

genomethreader (1.7.3+dfsg-3) unstable; urgency=medium

  * Use defined LANG when building to avoid breaking the Built-Using
    detection.

 -- Sascha Steinbiss <satta@debian.org>  Thu, 23 Jan 2020 11:03:30 +0100

genomethreader (1.7.3+dfsg-2) unstable; urgency=medium

  * Fix builds on some archs by removing -m32/-m64.
  * Use deterministic sorted wildcard order in Makefile.
  * Bump Standards-Version.

 -- Sascha Steinbiss <satta@debian.org>  Thu, 23 Jan 2020 00:02:20 +0100

genomethreader (1.7.3+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #948526)

 -- Sascha Steinbiss <satta@debian.org>  Thu, 09 Jan 2020 20:51:38 +0100
