=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               genometools,
-               libgenometools0-dev,
+               genometools (>= 1.6.1),
+               libgenometools0-dev (>= 1.6.1),
                libvmatch-dev,
                zlib1g-dev,
                libbz2-dev,
@@ -14,10 +14,10 @@
                libtre-dev,
                asciidoctor
 Standards-Version: 4.6.2
+Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/med-team/genomethreader
 Vcs-Git: https://salsa.debian.org/med-team/genomethreader.git
-Homepage: https://genomethreader.org
-Rules-Requires-Root: no
+Homepage: http://genomethreader.org
 
 Package: genomethreader
 Architecture: any
