=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

DH_VERBOSE := 1
export LC_ALL=C.UTF-8
export LANG=en_US.UTF-8
export LANGUAGE=en_US.UTF-8
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export LIBVMATCH_PKG_VERSION=$(shell apt-cache policy libvmatch-dev | grep Installed | cut -f2 -d: | cut -c2-)

DARCH:=$(shell dpkg-architecture | fgrep DEB_TARGET_ARCH= | cut -f 2 -d'=')
BITS:=$(shell dpkg-architecture | fgrep DEB_TARGET_ARCH_BITS= | cut -f 2 -d'=')

ifeq ($(BITS),64)
  64BIT:=yes
else
  64BIT:=no
endif

ifeq ($(DARCH),i386)
  EXTRATESTOPT:=nofastdp=yes
endif

%:
	dh $@

override_dh_auto_clean:
	dh_clean
	make licensemanager=no opt=yes 64bit=$(64BIT) cleanup
	rm -rf bin/bssm debian/bssm bin/gthdata debian/gthdata
	rm -rf $(CURDIR)/debian/man
	rm -f debian/*substvars

override_dh_auto_build:
	make licensemanager=no opt=yes 64bit=$(64BIT)
	make licensemanager=no opt=yes 64bit=$(64BIT) train

override_dh_auto_install:
	mv bin/bssm debian/bssm
	mv bin/gthdata debian/gthdata
	dh_auto_install

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	make licensemanager=no 64bit=$(64BIT) $(EXTRATESTOPT) test
endif

override_dh_installman:
	mkdir -p $(CURDIR)/debian/man
	asciidoctor -a docdate='' -b manpage $(CURDIR)/debian/man_src/*.adoc
	cp $(CURDIR)/debian/man_src/*.? $(CURDIR)/debian/man
	dh_installman --

override_dh_gencontrol:
	echo "libvmatch-dev:Version=$(LIBVMATCH_PKG_VERSION)" >> debian/genomethreader.substvars
	dh_gencontrol
